<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	http://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There area two reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router what URI segments to use if those provided
| in the URL cannot be matched to a valid route.
|
*/
$route['404_override']			= '';

$route['default_controller']	= "home";

$route['signup']	= "home/signup";
$route['inactive']	= "home/inactive";
$route['register']	= "home/entity_register";
$route['update_license']	= "home/update_license";

//setup page redirect to login
$route['setup']	= "user/login";
$route['setup/(:any)']	= "user/login";

$domain	= $this->config->item('main_domain');
$host	= $_SERVER['HTTP_HOST'];
$host	= str_replace('www.', '', $host);
if ($host != $domain)
{
	$subDomain	= str_replace('.' . $domain, '', $host);
	$route['default_controller'] = "dashboard";
	$route['signup'] = "user/login";
} else {
	$route['default_controller'] = "home";
}

$route['login'] = "user/login";
$route['logout'] = "user/logout";
$route['renew'] = "home/renew";
$route['files/(:any)']		= "attachment/file/$1";
$route['project/(:num)']	= "project/index/$1";
$route['clients/(:num)']	= "clients/index/$1";
$route['users/(:num)']		= "users/index/$1";
$route['tasks/(:num)']		= "tasks/index/$1";
$route['mytasks']	= "tasks/mytasks";
// $route['tasks/todo/(:num)']	= "tasks/todo/$1";
// Unpaid	- U,u
// Draft	- D,d
// Paid		- P,p
// Recurring- R,r
// Agging	- A,a
$route['invoice/([U|D|P|R|A|u|d|p|r|a]\d+)']	= "invoice/index/$1";
$route['estimate/(:num)']	= "estimate/index/$1";
$route['invoice/deposit/(:num)']	= "invoice/deposit/index/$1";
$route['api/v(:num)/time_entries/(:any)']	= "v$1/time_entries_v$1/$2";
$route['api/v(:num)/expenses/(:any)']	= "v$1/expenses_v$1/$2";
$route['api/v(:num)/auth/(:any)']	= "v$1/auth_v$1/$2";
$route['api/v(:num)/tasks/(:any)']	= "v$1/tasks_v$1/$2";
$route['api/v(:num)/entity/(:any)']	= "v$1/entity_v$1/$2";
$route['api/v(:num)/invoice/(:any)']	= "v$1/invoice_v$1/$2";
$route['api/v(:num)/clients/(:any)']	= "v$1/clients_v$1/$2";
