<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Entity_table extends Base_table {

	function __construct()
	{
		parent::__construct(array('tbl'=>'entity', 'tbl_key'=>'entity_id'));
	}
	
	public function formatdata(&$data)
	{
		$this->CI->load->library('Auth');
		
		$data['name'] 			= (! empty($data['name']))?$data['name']:$data['company_name'];
		if ($this->user_id) {
			$data['created_by'] 	= $this->user_id;
		}
		$data['created_by'] 	= (! empty($data['created_by']))?$data['created_by']:$data['user_id']; 
		$data['created_date']	= (! empty($data['created_date']))?$data['created_date']:$this->cur_time;
// 		$data['entity_logo']	= (!empty($data['entity_logo']))?substr($data['entity_logo'], 0, strpos($data['entity_logo'],'?')):'';
		if (isset($data['entity_logo']) && !$data['entity_logo'])
		{
			unset($data['entity_logo']);
		}

		if ($this->CI->config->item('SMX_signup_with_autologin'))
		{
			$data['is_active'] = 1;
		}

        return true;
    }

	public function save($data)
	{
		if(!empty($data['account_owner_id'])) 
		{
			$owner_id = $data['account_owner_id'];
		}
		if (parent::save($data))
		{
			if ($this->entity_id && !empty($data['name']))
			{
				$this->CI->db->where('entity_id', $this->entity_id);
				$this->CI->db->update('entity_accounts', array('company_name' => $data['name']));
			}
			if(!empty($owner_id))
			{
				$this->CI->db->where('entity_id', $this->entity_id);
				$this->CI->db->update('entity_setting', array('account_owner_id' => $owner_id));
			}
			return true;
		} 

		return false;
	}
}
/* end of Entity_table.php */
