﻿(function(Otime){

	Otime.Dashboard	= new function Dashboard(){
//		"use strict";

		var _this	= this;

		_this.name		= "dashboard";
		
		_this.appModel	= null;
		
		_this.filter_labels	= null;
		
		_this.month_names_short = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

		_this.project_hours = function(data) {
			var self = this;

			data	= data || {};
			self.billable_hours		= 	Otime.o(0);
			self.nonbillable_hours	= 	Otime.o(0);
			self.invoiced_hours		= 	Otime.o(0);
			self.uninvoiced_hours	= 	Otime.o(0);
			self.pr_amount			= 	Otime.a([]);

			self.today	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp	= Otime.o(new Date(self.date()).format(Otime.dateFormat));

			self._info	= {
				filters : Otime.o(data.filters),
				date_filter_type : Otime.o(data.date_filter_type || _this.dft || "TW"),
				date_filter_disp : Otime.o(_this.filter_labels[data.date_filter_type || _this.dft || "TW"])
			};

			self.refresh	= function(){
				var postData	= {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf)
				};

				Otime.app.loadData(new Otime.ContextModel('project_hours', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					self.billable_hours(0);
					self.nonbillable_hours(0);
					self.invoiced_hours(0);
					self.uninvoiced_hours(0);
					
					var tmpArr = [];
					self.max_total = 0;
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{	
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(val){
							self.billable_hours(self.billable_hours() + (val.billable_hours - 0));
							self.nonbillable_hours(self.nonbillable_hours() + (val.nonbillable_hours - 0));
							
							val.billable_hours = Number(val.billable_hours).toFixed() - 0;
							val.nonbillable_hours = Number(val.nonbillable_hours).toFixed() - 0;
							val.total_hours = val.billable_hours + val.nonbillable_hours;
							self.max_total = (self.max_total > val.total_hours)?self.max_total:val.total_hours;
							val.billable_hours_per = (val.billable_hours / val.total_hours) * 100;
							tmpArr.push(val);
							
							if (val.invoiced_hours) {
								self.invoiced_hours(self.invoiced_hours() + (val.invoiced_hours - 0));
								self.uninvoiced_hours(self.uninvoiced_hours() + (val.uninvoiced_hours - 0));
								val.invoiced_hours = Number(val.invoiced_hours).toFixed() - 0;
								val.uninvoiced_hours = Number(val.uninvoiced_hours).toFixed() - 0;
							}
						});
					}
					self.pr_amount(tmpArr.slice());
				}));
			};
			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT(data.date_filter_type || "TY");
		};

		_this.output_hours = function(data) {
			var self = this;

			data	= data || {};

			self.stackedBar	= Otime.a([]);
			self.stack	= Otime.o(false);
			self.colors= Otime.a([]);
			self.ticks= Otime.a([]);
//			self.stackedBar= Otime.a([]);
			self.show_chart= Otime.o(false);
			self.is_team_view= Otime.o(Otime.Dashboard.is_team_view || false);
			
			self.total			= 	Otime.o(0);
			self.billable		= 	Otime.o(0);
			self.non_billable	= 	Otime.o(0);

			self.today	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp	= Otime.o(new Date(self.date()).format(Otime.dateFormat));

			self._info	= {
				filters : Otime.o(data.filters),
				date_filter_type : Otime.o("TM"),
				date_filter_disp : Otime.o(_this.filter_labels["TM"])
			};

			self.refresh	= function(){
				var postData	= {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf),
					team_view: Number(self.is_team_view())
				};

				Otime.app.loadData(new Otime.ContextModel('output_hrs', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					var bhrs = {};
					var nbhrs = {};
					var tmp_label = [];
					var label = [];
					var k =0;
					
					var start_date = new Date(self.date_filter.from_date());
					var end_date   = new Date(self.date_filter.to_date());
					var st_mn 		= end_date.getMonth() -start_date.getMonth();
					var diff = (new Date(end_date - start_date))/1000/60/60/24;
					var sql_date 	=  new Date();

					while (end_date.isAfter(start_date) || !end_date.isBefore(start_date))
					{
						sql_date = start_date.format(Otime.sdf);
						if (diff>7 && st_mn) {
							sql_date = _this.month_names_short[start_date.getMonth()];
						} else {
							sql_date = (diff<7)?start_date.format(Otime.sdf):start_date.getDate();
						}
						bhrs[sql_date] = [k,0];
						nbhrs[sql_date] = [k,0];
						tmp_label[k]		= sql_date;
						
						if (diff>7 && st_mn) {
							start_date = start_date.addMonth(1);
						} else {
							sql_date = (diff>7)?sql_date:new Date(sql_date).format(Otime.dateFormat);
							start_date = start_date.addDays(1);
						}
						label.push([k, sql_date]);
						k++;
					}
					
					self.billable(0);
					self.non_billable(0);
					self.total(0);

					if (resp.items && resp.items.length > 0)
					{
						var date_index	= null;
						$.each(resp.items, function(key, val){
							val.group_entry = Number(val.group_entry)?Number(val.group_entry):val.group_entry;
							date_index = tmp_label.indexOf(val.group_entry);
							bhrs[val.group_entry] = [date_index, val.billable_hours];
							nbhrs[val.group_entry] = [date_index, val.nonbillable_hours];
							self.billable(self.billable() + Number(val.billable_hours));
							self.non_billable(self.non_billable ()+ Number(val.nonbillable_hours));
						});
						self.total(self.billable() + self.non_billable());
					}

					tmpArr.push({label:'Billable', data:Object.values(bhrs)});
					tmpArr.push({label:'Non-Billable', data:Object.values(nbhrs)});
					var colors = ["#52D793","#FC8660"];
					self.stack(true);
					self.colors(colors);
					self.ticks(label);
					self.stackedBar(tmpArr.slice());
					self.show_chart(true);
				}));
			};
			
			self.swap_view	= function() {
				self.is_team_view(!self.is_team_view());
				self.refresh();
			}

			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT("TM");
		};
		
		_this.amount_hours = function(data) {
			var self = this;

			data	= data || {};

			self.stackedBar	= Otime.a([]);
			self.stack	= Otime.o(false);
			self.colors= Otime.a([]);
			self.ticks= Otime.a([]);
			self.show_chart= Otime.o(false);
			
//			self.paid			= 	Otime.o(0);
//			self.unpaid			= 	Otime.o(0);
//			self.total		= 	Otime.o(0);

			self.today	= Otime.o(new Date().format("yyyy/mm/dd"));

			self.refresh	= function(){
				var postData	= {};

				Otime.app.loadData(new Otime.ContextModel('amount_hours', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					var paid_amount = [];
					var unpaid_amount = [];
					var label = [];
					var k =0;
					
//					self.paid(0);
//					self.unpaid(0);
//					self.total(0);

					var tmp_label = [];
					var tmp_incamt = [];
					var tmp_expamt = [];
					
					var start_date = new Date(self.today());				
					var sql_date 	=  new Date();
					k = 5;
					for (var i=0;i<6;i++)
					{
						sql_date = _this.month_names_short[start_date.getMonth()];
						paid_amount[sql_date] = [k,0];
						unpaid_amount[sql_date] = [k,0];
						tmp_label[k]		= sql_date;
						label.push([k, sql_date]);
						k--;
						start_date = start_date.addMonth(-1);
					}

					if (resp.items && resp.items.length > 0)
					{
						var date_index	= null;
						$.each(resp.items, function(key, val){								
							date_index = tmp_label.indexOf(val.month_str);
							paid_amount[val.month_str] = [date_index, val.paid_amount];
							unpaid_amount[val.month_str] = [date_index, val.unpaid_amount];								
						});
					}
					
					tmpArr.push({label:'Paid', data:Object.values(paid_amount)});
					tmpArr.push({label:'Unpaid', data:Object.values(unpaid_amount)});
					var colors = ["#CE91DB", "#C96B4C"];
					self.stack(true);
					self.colors(colors);
					self.ticks(label);
					self.stackedBar(tmpArr.slice());
					self.show_chart(true);
				}));
			};
			self.refresh();

		};
		
		_this.income_expenses = function(data) {
			var self = this;

			data	= data || {};

			self.stackedBar	= Otime.a([]);
			self.colors= Otime.a([]);
			self.ticks= Otime.a([]);
			self.multiBar= Otime.a([]);
			self.show_chart= Otime.o(false);
			
			self.total			= 	Otime.o(0);
			self.income			= 	Otime.o(0);
			self.expenses		= 	Otime.o(0);

			self.today	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp	= Otime.o(new Date(self.date()).format(Otime.dateFormat));
			
			self._info	= {
				filters : Otime.o(data.filters),
				date_filter_type : Otime.o(data.date_filter_type || _this.exp_dft || "TW"),
				date_filter_disp : Otime.o(_this.filter_labels[data.date_filter_type || _this.exp_dft || "TW"])
			};
			self.refresh	= function(){
				var postData	= {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf)
					// team_view: Number(self.is_team_view())
				};

				Otime.app.loadData(new Otime.ContextModel('income_expenses', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					var inc_amount = [];
					var exp_amount = [];
					var label = [];
					var k =0;
					
					self.income(0);
					self.expenses(0);
					self.total(0);

					var tmp_label = [];
					var tmp_incamt = [];
					var tmp_expamt = [];
					
					var start_date = new Date(self.date_filter.from_date());
					var end_date   = new Date(self.date_filter.to_date());
					var st_mn 		= end_date.getMonth() -start_date.getMonth();
					
					var sql_date 	=  new Date();
					
					while (end_date.isAfter(start_date) || !end_date.isBefore(start_date))
					{
						sql_date = _this.month_names_short[start_date.getMonth()];
						tmp_incamt[sql_date] = [k,0];
						tmp_expamt[sql_date] = [k,0];
						tmp_label[k]		= sql_date;
						label.push([k, sql_date]);
						k++;
						start_date = start_date.addMonth(1);
					}

					if (resp.items && resp.items.length > 0)
					{
						var date_index	= null;
						$.each(resp.items, function(key, val){								
							date_index = tmp_label.indexOf(val.month_str);
							if (val.inc_amount)
							{
								tmp_incamt[val.month_str] = [date_index, val.inc_amount];
								self.income(self.income() + Number(val.inc_amount));
							}
							if (val.exp_amount)
							{
								tmp_expamt[val.month_str] = [date_index, val.exp_amount];
								self.expenses(self.expenses ()+ Number(val.exp_amount));
							}								
						});
						self.total(self.income() - self.expenses());
					}
					
					tmpArr.push({label:'Income', data:Object.values(tmp_incamt)});
					tmpArr.push({label:'Expenses', data:Object.values(tmp_expamt)});
					var colors = ["#7cb5ec", "#f7a35c"];
					self.colors(colors);
					self.ticks(label);
					self.multiBar(tmpArr.slice());
					self.show_chart(true);
				}));
			};
			
//			self.swap_view	= function() {
//				self.is_team_view(!self.is_team_view());
//				self.refresh();
//			}

			var ie_trg = false;
			var ie_timer = setTimeout(function() {
				ie_trg=true;
				self.refresh();
				self.date_filter.applyDFT(data.date_filter_type || _this.exp_dft || "TW");
			}, 5000);
			$( "#main-container" ).scroll(function() { 
				if (ie_trg) return;
				window.clearTimeout(ie_timer);
				self.refresh();
				ie_trg=true;
			});
			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT(data.date_filter_type || _this.exp_dft || "TW");
			
		};
		
		_this.task_types = function(data) {
			var self = this;

			data	= data || {};
			
			self.pieChart	= Otime.a([]);
			self.project_id = Otime.o(data.project_id || 0);
			self.colors		= [];

			self.project_id.subscribe(function(newVal){
				self.refresh();
			});

			self.refresh	= function(){
				if (!self.project_id())
				{
					return;
				}

				var postData	= {
					project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('task_types', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					var color = [];
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{						
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(item){
							var val = [];
							if (item.hours-0)	
								tmpArr.push({label:item.name, data:Number(item.hours)});

						});
					}					
					self.colors = color;

					self.pieChart(tmpArr.slice());
				}));
			};
//			self.refresh();
		};
		
		_this.task_status = function(data) {
			var self = this;

			data	= data || {};
			
			self.pieChart	= Otime.a([]);
			self.project_id = Otime.o(data.project_id || 0);
			self.colors		= [];

			self.project_id.subscribe(function(newVal){
				self.refresh();
			});

			self.refresh	= function(){
				if (!self.project_id())
				{
					return;
				}

				var postData	= {
					project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('task_status', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					var color = [];
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(item){
							var val = [];
							if (!resp.sts_color[item.task_status_id]) {
								return true;
							}
							val = resp.sts_color[item.task_status_id];							
							tmpArr.push({label:val.name, data:Number(item.count)});
							color.push(val.bg_color);

						});
					}					
					self.colors = color;

					self.pieChart(tmpArr.slice());
				}));
			};
//			self.refresh();
		};
		
		
		_this.project_alertlist = function(data) {
			var self = this;
			data	= data || {};
			
			self.listing = Otime.a([]);
			self.refresh	= function(){
				var postData	= {
						//project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('project_alerts', postData, function(cont){
					var resp	= cont.response;
					
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{
						var tmpArr = [];
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(val){
							var new_alt = new _this.project_alert(val);
							if (new_alt.is_display)
								tmpArr.push(new_alt);
						});
						self.listing(tmpArr);
					}
				}));
			};
			self.refresh();
		}
		
		_this.project_alert = function(val) {
			var self = this;

			val	= val || {};

			self.exe_estcnt = Number(val.exe_estcnt || 0);
			self.exe_datecnt = Number(val.exe_estcnt || 0);
			self.project_name = val.project_name || '';
			self.act_val = 0;
			self.bud_val = 0;
			self.bud_alt_val	= val.budget_alert_percent - 0;
			self.bug_type		= " "+((val.budget_type.substr(0,1) == "A")? Otime.Currency : "hrs");
			self.is_display = 0;
			self.types		= Otime.a([]);
			if (self.bud_alt_val) {
				val.budget_value = val.budget_value * (self.bud_alt_val/100);
			}
			if (val.actual_value > val.budget_value)
			{
				self.act_val = Number(val.actual_value).toFixed(2);
				self.bud_val = Number(val.budget_value).toFixed(2);
			}
			
			if (val.types && val.types.length > 0)
			{
				var tmpArr = [];
				$.each(val.types, function(key, type){
					type.act_hrs = Number(type.act_hrs);
					type.estimated_hours = Number(type.estimated_hours);
					if (type.estimated_hours) {
						self.is_display = 1;
					}
					if (type.act_hrs > type.estimated_hours)
						tmpArr.push(type);
				});
				self.types(tmpArr);
			}

			if ((self.bud_val-0) && (self.exe_estcnt + self.exe_datecnt + self.act_val + self.bud_val + self.types.length) && (self.act_val > (self.bud_val-0))) {
				self.is_display = 1;
			}
		};
		
		
		_this.milestones = function(data) {
			var self = this;

			data	= data || {};
			
			//self.listing = Otime.a([]);
			self.duetoday = Otime.o(0);
			self.overdue = Otime.o(0);
			self.upcoming = Otime.o(0);
			self.project_id = Otime.o(data.project_id || 0);

			self.project_id.subscribe(function(newVal){
				self.refresh();
			});

			self.refresh	= function(){
				var postData	= {
					project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('milestones', postData, function(cont){
					var resp	= cont.response[0];
					
					self.duetoday(resp.due_today!=null?resp.due_today:0);					
					self.overdue(resp.overdue!=null?resp.overdue:0);					
					self.upcoming(resp.upcoming!=null?resp.upcoming:0);					
				}));
			};

			var ms_trg = false;
			var ms_timer = setTimeout(function() {
				ms_trg=true;
				self.refresh();
			}, 5000);
			$( "#main-container" ).scroll(function() { 
				if (ms_trg) return;
				window.clearTimeout(ms_timer);
				self.refresh();
				ms_trg=true;
			});
		};
		
		_this.outstanding_invoices = function(data) {
			var self = this;

			data	= data || {};
			
			self.listing = Otime.a([]);;
			self.total_due = 0;
			self.refresh	= function(){
				var postData	= {
						// project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('outstanding_invoices', postData, function(cont){
					var resp	= cont.response;
					
					var tmpArr = [];
					$.each(resp.items, function(key, val){
						val = Number(val);
						// if (val) {
							self.total_due = self.total_due + val;
							tmpArr.push({name:key, amount:val.toFixed(2)});
						// }
					});
					self.listing(tmpArr);					
				}));
			};
			self.refresh();
		};
		
		_this.dashboard = function(data) {
			var self	= this;

			self.projects	= Otime.a([]);

			Otime.app.loadData(new Otime.ContextModel('details', null, function(cont){
				var response = cont.response;
				if (response.projects && response.projects.otvalues)
				{
					response.projects	= response.projects.otvalues.setKeys(response.projects.otkeys);
					self.projects(response.projects);

//					var project_id	= response.projects[0].project_id;
//					self.ts_sts().project_id(project_id);
//					self.ty_sts().project_id(project_id);
				}
			}));

			self.ts_hrs	= Otime.o(new _this.output_hours());
			self.pr_hrs	= Otime.o(new _this.project_hours());

			if (Otime.usr == 3)
			{
				self.out_invoices	= Otime.o(new _this.outstanding_invoices());
				self.amt_hrs	= Otime.o(new _this.amount_hours());
				self.inc_exp	= Otime.o(new _this.income_expenses());
			}

			self.ts_sts	= Otime.o(new _this.task_status());
			self.ty_sts	= Otime.o(new _this.task_types());
			self.pr_alt	= Otime.o(new _this.project_alertlist());
			self.milestones	= Otime.o(new _this.milestones());
		};

		_this.loadTemplates	= function(clbk){
			var url	= Otime.siteUrl + '/dashboard/template?v=' + Otime.version + '&r=' + Otime.usr;
			$.get(url, function(content){
				$("#dashboard-container").append(content);
				typeof clbk === 'function' && clbk();
			});
		};

		_this.init	= function(){
			var data	= {};
			_this.appModel	= new _this.dashboard();

			ko.applyBindings(_this.appModel, $("#dashboard-container").get(0));
		};
	};
}(window.Otime));
