//update: function(element, valueAccessor, allBindingsAccessor, viewModel, bindingContext) {

var helperObj	= {};

ko.extenders.trackChange = function (target, track) {
	if (track)
	{
		target.isDirty	= ko.observable(false);
		target.originalValue	= target();
		if ($.isArray(target.originalValue)) {
			target.originalValue	= JSON.parse(JSON.stringify(target()));		
		}
		target.subscribe(function (newValue) {
			var is_dir = newValue != target.originalValue;

			if ($.isArray(target.originalValue)) {
				is_dir = target.originalValue.toString() != newValue.toString();
			}

			target.isDirty(is_dir);
		});
		target.update	= function(){
			target.originalValue	= target();
		};
	}
	return target;
};
ko.extenders.taskChange	= function(target, track){
	if (track)
	{
		target.originalValue	= target();
		target.update	= function(){
			target.originalValue	= target();
		};
		if ($.isArray(target.originalValue))
		{
			target.originalValue	= JSON.parse(JSON.stringify(target()));
			target.isDirty	= function(){
				return (target.originalValue.toString() != JSON.parse(JSON.stringify(target())).toString());
			};
		}
		else
		{
			target.isDirty	= function(){
				if (!target.originalValue && !target())
				{
					return false;
				}
				return target.originalValue != target();
			};
		}
	}
	return target;
};
var speed	= 200;
ko.bindingHandlers.slideVisible	= {
	init: function(element, valueAccessor) {
		$(element).toggle(ko.utils.unwrapObservable(valueAccessor()));
	},
	update: function(element, valueAccessor) {
		var $mainContainer = $("#main-container");
		var $listContainer = $('#list-container');
		element	= $(element);

		if (ko.utils.unwrapObservable(valueAccessor()))
		{
			element.show();
		}
		else
		{
			$listContainer.removeClass("opened");
			$(".backdrop").hide();
			element.hide();
		}
	}
};
//ko.bindingHandlers.slideIn = {
//    init: function (element, valueAccessor) {
//        var value = ko.utils.unwrapObservable(valueAccessor());
//        $(element).toggle(value);
//    },
//    update: function (element, valueAccessor) {
//        var value = ko.utils.unwrapObservable(valueAccessor());
//        value ? $(element).slideDown() : $(element).slideUp();
//    }
//};
ko.bindingHandlers.img	= {
//	init: Otime.UpdateImage,
	update: function(element, params) {
		$(element).attr("onerror", "javascript:onImageError(this);");
		if (ko.utils.unwrapObservable(params()) != "")
		{
			$(element).removeClass("noImg").attr("src", ko.utils.unwrapObservable(params()));
		}
	}
};

ko.bindingHandlers.autoComplete	= {
	init: function (element, params) {
		_params	= params();

		$container	= $('<div class="auto-complete-container"></div>');
		$(element).after($container.get(0));
		_params.appendTo	= $container.get(0);
		_params.minLength	= 0;
		$(element).autocomplete(_params).data("autocomplete")._renderItem = function(ul, item) {
			return $( "<li></li>" ).data("item.autocomplete", item).append("<a>" + item.label + "</a>" ).appendTo(ul);
		};
		$(element).click(function(){
			if ($(this).val()=="")
				$(this).autocomplete("search");
		});
	},
	update: function (element, params) {
		$(element).autocomplete("option", "source", params().source);
	}
};

ko.bindingHandlers.autosize	= {
	init: function (element, params) {
		if ($(element).is("textarea") && autosize)
		{
			autosize($(element));
		}
	}
//	update: function (element, params) {
//		autoresize($(element));
//	}
};

//ko.bindingHandlers.spinner	= {
//	init: function (element, params) {
//		_params	= {
//			min: params().min || 0,
//			max: params().max || 100,
//			step: params().step || 1
//		};
//		$(element).spinner(_params);
//		$(element).on("spinchange", function(){
//			$(this).trigger('change');
//		});
//	}
//};

ko.bindingHandlers.fancy	= {
	init: function(element, params){
		$(element).uniform();
	},
	update: function(element, params){
		$.uniform.update();
	}
};

ko.bindingHandlers.selectpicker	= {
	init: function(element, params){
		$(element).selectpicker();
	},
	update: function(element, params){
		$(element).selectpicker('refresh');
	}
};

ko.bindingHandlers.cls	= {
	update: function(element, params){
//		$(element).addClass(params());
		params	= ko.utils.unwrapObservable(params());
		var className	= ko.utils.unwrapObservable(params);
		if (className && className != "0")
		{
			ko.bindingHandlers.css.update(element, function(){ return className; });
		}
	}
};

ko.bindingHandlers.masonry	= {
	init: function(element, params){
		var _params	= params() || {};
		_params.itemSelector	= _params.itemSelector || '.masoItm';
		_params.columnWidth		= _params.columnWidth || 0;
		$(element).masonry(_params);
	},
	update: function(element){
//		$(element).masonry('reload');
	}
};

ko.bindingHandlers.chosen	= {
	init: function(element, params){
		var $element = $(element);
		var _params	= (typeof params() == 'object') ? params() : {};
		_params.search_contains	= ko.utils.unwrapObservable(_params.search_contains);
		_params.disable_search	= ko.utils.unwrapObservable(_params.isSearch) === false ? true : false;
//		_params.disable_search	= (_params.disable_search===false) ? true : false;
		_params.width	= _params.width || '100%';

		$element.chosen(_params);
		if(_params.change)
		{
			$element.chosen().on("change", function (evt, params) {
				_params.change($(this),params);
			});
		}
		if (typeof _params.open == 'function')
		{
			$element.chosen().on("chosen:showing_dropdown", function (evt, params) {
				_params.open($(this), evt, params);
			});
		}
		if (typeof _params.close == 'function')
		{
			$element.chosen().on("chosen:hiding_dropdown", function (evt, params) {
				_params.close($(this), evt, params);
			});
		}
	},
	update: function(element, params){
		$(element).trigger("chosen:updated");
	}
};/*
ko.bindingHandlers.selectator	= {
	init: function(element, params){
		var $element = $(element);
		var _params	= (typeof params() == 'object') ? params() : {};

		$element.selectator({
			useSearch: true,
			showAllOptionsOnFocus: true,
			labels: {
				search: 'Search here...'
			}
		});
	},
	update: function(element, params){
		$(element).selectator('refresh');
	}
};
ko.bindingHandlers.selectatorImg	= {
	init: function(element, params){
		var elem	= $(element);
		var _params	= (typeof params() == 'object') ? params() : {};
		var title	= ko.utils.unwrapObservable(_params.title);
		var src	= ko.utils.unwrapObservable(_params.src);

		if (!src)
			return false;

		elem.attr('data-left', '<img src="' + src + '" title="' + title + '" onerror="onImageError(this);" />');
	},
	update: function(element, params){
		
	}
};
*/
ko.bindingHandlers.datepicker	= {
	init: function(element, params){
		params	= ko.utils.unwrapObservable(params());
		var _params	= {};

		_params.startView	= ko.utils.unwrapObservable(params.startView) || 0;
		_params.viewMode	= ko.utils.unwrapObservable(params.viewMode) || 0;
		_params.minViewMode	= ko.utils.unwrapObservable(params.minViewMode) || 0;
		_params.weekStart	= ko.utils.unwrapObservable(params.weekStart) || Otime.Days.getPos(Otime.weekStart)-1 || 0;
		_params.endDate		= ko.utils.unwrapObservable(params.endDate) || null;
		_params.startDate	= ko.utils.unwrapObservable(params.startDate) || null;
		_params.range		= ko.utils.unwrapObservable(params.range) || null;
		_params.format		= ko.utils.unwrapObservable(params.format) || "yyyy/mm/dd";
		_params.orientation	= ko.utils.unwrapObservable(params.orientation) || "auto";
		_params.autoclose	= true; // !!ko.utils.unwrapObservable(_params.autoclose);
		_params.container	= params.container || "body";
		_params.forceParse	= false;
		_params.enableOnReadonly	= false;
		_params.todayHighlight	= true;
//		_params.setValue	= ko.utils.unwrapObservable(params.setDate) || "";
		setTimeout(function(){
			$(element).datepicker(_params);
		}, 2);
	},
	update: function(element, params){
		var elem	= $(element),dt;

		if (elem.data("datepicker"))
		{
			dt	= new Date(elem.val());
			elem.datepicker('update', isNaN(dt.getTime()) ? "" : new Date(elem.val()));
			elem.datepicker('update');
		}
	}
};

ko.bindingHandlers.colorpicker	= {
	init: function(element, params){
		params	= ko.utils.unwrapObservable(params)();
		var _params	= {};
		_params.isTextColor	= !!ko.utils.unwrapObservable(params.isText);
		_params.value	= ko.utils.unwrapObservable(params.value);
		_params.colors	= ko.utils.unwrapObservable(params.colors);
		_params.align	= ko.utils.unwrapObservable(params.align) || "center";
		var onChange	= function(color){
			ko.isObservable(params.value) && params.value(color);
		};
		_params.onChange	= ko.utils.unwrapObservable(params.onChange) || onChange;
		$(element).colorpicker(_params);
		if($(element).hasClass('background-picker')){
			var imgtag = '<img src="'+Otime.baseUrl+'assets/img/paint.png" width="16" height="16" class="col-picker-handler">';
			$(element).children().append(imgtag);
		}
	},
	update: function(element, params){
		
		// $(element).colorpicker();
	}
};

ko.bindingHandlers.timeEntry	= {
	init: function(element, params){
//		var _params	= (typeof params() == "object") ? params() : {};
		var _params	= ko.utils.unwrapObservable(params());

		_params.spinnerImage	= '';
		_params.timeSteps		= _params.timeSteps || [1, 1, 1];
		_params.useMouseWheel	= true;
		_params.initialField	= _params.initialField || 0;
		_params.defaultTime		= _params.defaultTime || "00:00 AM";
		_params.show24Hours		= _params.hourFormat || Otime.hourFormat;
		_params.separator		= _params.separator || ':';
		_params.ampmPrefix		= ' ';
		_params.autoAMPM		= !!_params.autoAMPM;
		if (_params.minTime)
			_params.minTime		= ko.utils.unwrapObservable(_params.minTime);

//		Otime.hoursEntry;
//		var d	= new Date();
//		d	= new Date(d.getFullYear(), d.getMonth(), d.getDate(), 00, 00, 00);
//		_params.minTime			= _params.minTime || d;

		_params.date	= ko.utils.unwrapObservable(_params.date);
		if (_params.date && new Date(_params.date).format(Otime.jdf) == Otime.Date().format(Otime.jdf))
		{
			_params.maxTime	= _params.maxTime || Otime.Date().format("HH:NN AP");
		}

		$(element).timeEntry(_params);
	}//,
//	update: function(element, params){
//		var _params	= ko.utils.unwrapObservable(params());
//		_params.minTime	= ko.utils.unwrapObservable(_params.minTime);
//		_params.date	= ko.utils.unwrapObservable(_params.date);
//		if (_params.date && new Date(_params.date).format(Otime.jdf) == Otime.Date().format(Otime.jdf))
//		{
//			_params.maxTime	= _params.maxTime || Otime.Date();
//		}
//		_params.date	= null;
//		$(element).timeEntry('option', _params);
//	}
};

ko.bindingHandlers.time	= {
	update: function(element, params){
		params	= ko.utils.unwrapObservable(params)();

		var is24Hr	= params.hourFormat || Otime.hourFormat;

		var time	= ko.utils.unwrapObservable(params);
		if (time)
			time	= new Date("2014/01/01 " + time).format(is24Hr ? "OO:NN" : "HH:NN AP");

		return ko.bindingHandlers.text.update(element, function(){
			return time;
		});
	}
};
ko.virtualElements.allowedBindings.time	= true;

ko.bindingHandlers.currency	= {
	update: function(element, params){
		params	= ko.utils.unwrapObservable(params)();

		var symbol	= ko.utils.unwrapObservable(params.symbol) || Otime.Currency || "";
		var value	= ko.utils.unwrapObservable(params.val);
		var _fix	= ko.utils.unwrapObservable(params.fix);

		value	= symbol + Otime.Number(value, null, _fix);

		return ko.bindingHandlers.html.update(element, function(){
			return value;
		});
	}
};
ko.virtualElements.allowedBindings.currency	= true;

ko.bindingHandlers.vtext	= {
	update: function(element, params){
		params	= ko.utils.unwrapObservable(params());
		params	= ko.utils.unwrapObservable(params);

		if (!isNaN(params-0))
		{
			params	= params-0;
		}

		return ko.bindingHandlers.text.update(element, function(){
			return params ? params : '';
		});
	}
};
ko.virtualElements.allowedBindings.vtext	= true;

ko.bindingHandlers.numberOnly	= {
	init: function(element, params){
		params	= ko.utils.unwrapObservable(params)();
		params.keyCodes	= ko.utils.unwrapObservable(params.keyCodes);

		// dot, enter
		var keyCodes	= [8, 0, 46, 13];
		if (params.keyCodes && params.keyCodes.length)
		{
			keyCodes	= $.merge(keyCodes, params.keyCodes);
		}
		if (params.comma)
			keyCodes	= $.merge(keyCodes, [44]);

		$(element).keypress(function (e) {
			return !(keyCodes.indexOf(e.which) < 0 && (e.which < 48 || e.which > 57));
		});
	}
};

ko.bindingHandlers.log	= {
	update: function(element, params){
		console.log("Handler : ", params());
	}
};
//ko.bindingHandlers.sl	= {
//	init: function(element, params){
//		$(element).click(function(){
//			$(this).select();
//		});
//	}
//};

ko.observableArray.fn.append	= function(valuesToPush){
	var underlyingArray = this();
	this.valueWillMutate();
	ko.utils.arrayPushAll(underlyingArray, valuesToPush);
	this.valueHasMutated();
	return this;
};

ko.observableArray.fn.prepend	= function(valuesToPush){
	var underlyingArray = this() || [];
	this.valueWillMutate();
	
	for (var i=0, j=valuesToPush.length; i<j; i++)
	{
		underlyingArray.splice(i, 0, valuesToPush[i]);
	}

	this.valueHasMutated();

	return this;
};
ko.observableArray.fn.prependSingle	= function(valueToPush, pushAt){
	var underlyingArray = this() || [];
	pushAt	= pushAt || 0;
	this.valueWillMutate();
	underlyingArray.splice(pushAt, 0, valueToPush);
	this.valueHasMutated();
	return this;
};
//ko.observableArray.fn.subscribeArrayChanged = function(addCallback, deleteCallback){
//	var previousValue = undefined;
//	this.subscribe(function(_previousValue) {
//		previousValue = _previousValue.slice(0);
//	}, undefined, 'beforeChange');
//	this.subscribe(function(latestValue) {
//		var editScript = ko.utils.compareArrays(previousValue, latestValue);
//		for (var i = 0, j = editScript.length; i < j; i++) {
//			switch (editScript[i].status) {
//				case "retained":
//					break;
//				case "deleted":
//					if (deleteCallback)
//						deleteCallback(editScript[i].value);
//					break;
//				case "added":
//					if (addCallback)
//						addCallback(editScript[i].value);
//					break;
//			}
//		}
//		previousValue = undefined;
//	});
//};

ko.bindingHandlers.show	= {
//	init: visibleElem,
	update: function(element, valueAccessor) {
		var value	= ko.utils.unwrapObservable(valueAccessor());
		if (value == true)
		{
			$(element).css("visibility", "visible");
		}
		else
		{
			$(element).css("visibility", "hidden");
		}
	}
};
ko.bindingHandlers.hidden = {
	update: function(element, valueAccessor) {
		var value	= ko.utils.unwrapObservable(valueAccessor());
		ko.bindingHandlers.visible.update(element, function(){
			return !value;
		});
	}
};

ko.bindingHandlers.readonly = {
	update: function(element, valueAccessor) {
		if (ko.utils.unwrapObservable(valueAccessor())) {
			element.setAttribute('readonly', 'readonly');
		} else {
			element.removeAttribute('readonly');
		}
	}
};
ko.bindingHandlers.nreadonly = {
	update: function(element, valueAccessor) {
		if (ko.utils.unwrapObservable(valueAccessor())) {
			element.removeAttribute('readonly');
		} else {
			element.setAttribute('readonly', 'readonly');
		}
	}
};

ko.bindingHandlers.symbol	= {
	init: function(element, params){
		var params	= ko.utils.unwrapObservable(params()),
		divTag	= $('<div class="symbol-cont"></div>'),
		spanTag	= $('<span class="symbol">' + params + '</span>');

		divTag.insertAfter($(element));
		$(element).appendTo(divTag).css({'padding-right':(spanTag.innerWidth()+3)+'px'});
		spanTag.appendTo(divTag);
	},
	update: function(element, params){
		var params	= ko.utils.unwrapObservable(params()),
		spanTag	= $('.symbol', $(element).parent());
		spanTag.html(params);
		$(element).css({'padding-right':(spanTag.innerWidth()+3)+'px'});
	}
};

ko.bindingHandlers.fileApi	= {
	init: function(element, params){
		var params	= ko.utils.unwrapObservable(params());
		params.fileField	= element;
		params.init();
	}
};

ko.bindingHandlers.gridify	= {
	init: function(element, params){
		var params	= ko.utils.unwrapObservable(params());
		$(element).gridify(params);
	}
};

ko.bindingHandlers.title	= {
	update: function(element, params){
		var params	= ko.utils.unwrapObservable(params());
		var txt	= ko.utils.unwrapObservable(params.value) || "";
		var len	= ko.utils.unwrapObservable(params.length) || 21;
		var suff	= ko.utils.unwrapObservable(params.suffix) || "..";

		if (txt.length > len)
		{
			txt	= txt.substr(0, len) + suff;
		}

		return ko.bindingHandlers.html.update(element, function(){
			return txt;
		});
	}
};
ko.bindingHandlers.indexValue	= {
	init: indexValue,
	update: indexValue
};
function indexValue(element, params, allBindings, data, context){
	var _params	= params();
	_params(context.$index()+1);
}
ko.bindingHandlers.toggleopt = {
	update: function(element, params, allBindings, data, context){
		var params	= ko.utils.unwrapObservable(params());
		$.each(params, function(k, v){
			$("option[value='"+v+"']", $(element)).attr("disabled", "disabled");
		});
	}
};
helperObj.returnAsDate	= function(value, element, format){
	var _date	= new Date(value);

	return ko.bindingHandlers.text.update(element, function(){
		if (isNaN(_date.getTime()))
		{
			return "";
		}
		return _date.format(format || Otime.dateFormat || "DD-MM-YYYY");
	});
};
function bytesToSize(bytes) {
	if(bytes == 0)
		return '0 Byte';
	var k	= 1000;
	var sizes	= ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
	var i	= Math.floor(Math.log(bytes) / Math.log(k));
	return (bytes / Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
}
ko.bindingHandlers.fsize	= {
	update: function(element, valueAccessor){
		var value	= ko.utils.unwrapObservable(valueAccessor());
		var prefix	= "";
		var ret	= "";

		if (isNaN(value))
		{
			prefix	= ko.utils.unwrapObservable(value.prefix);
			value	= ko.utils.unwrapObservable(value.val);
		}

		ret	= prefix + bytesToSize(value);

		return ko.bindingHandlers.text.update(element, function(){
			return ret;
		});
	}
};
ko.virtualElements.allowedBindings.fsize	= true;

ko.bindingHandlers.date	= {
	update: function(element, valueAccessor) {
		var value	= ko.utils.unwrapObservable(valueAccessor());

		if (!value)
		{
			return ko.bindingHandlers.text.update(element, function(){
				return "";
			});
		}

		if (value instanceof Date || (typeof value == "string"))
		{
			return helperObj.returnAsDate(value, element);
		}

		var _date	= ko.utils.unwrapObservable(value.date) || "";
		var _type	= ko.utils.unwrapObservable(value.type) || "";
		var _format	= ko.utils.unwrapObservable(value.format) || Otime.dateFormat || "DD-MM-YYYY";

		if (_date instanceof Date)
		{
			return helperObj.returnAsDate(_date, element, _format);
		}

		if(_type != "" && (_type == 'S'|| _type == 'N'))
		{
			return ko.bindingHandlers.text.update(element, function(){
				return _date;
			});
		}

		//var tmp	= new Date(_date);
		var tmp	= new Date((_date+"").replace(".","DUMMY"));

		if (tmp+"" == "Invalid Date")
		{
			return ko.bindingHandlers.text.update(element, function(){
				return _date;
			});
		}
		_date	= tmp;

		var _if		= ko.utils.unwrapObservable(value.fi);
		_if	= (_if == undefined ? true : _if);

		if (_if && value.td && _date.isToday())
		{
			if (value.tdcss)
			{
				ko.bindingHandlers.css.update(element, function(){
					return value.tdcss;
				});
			}

			return ko.bindingHandlers.text.update(element, function(){
				return value.td;
			});
		}
		else if (_if && value.ye && new Date(_date).addDays(1).isToday())
		{
			if (value.yecss)
			{
				ko.bindingHandlers.css.update(element, function(){
					return value.yecss;
				});
			}

			return ko.bindingHandlers.text.update(element, function(){
				return value.ye;
			});
		}
		else if (_if && value.tm && new Date(_date).addDays(-1).isToday())
		{
			if (value.tmcss)
			{
				ko.bindingHandlers.css.update(element, function(){
					return value.tmcss;
				});
			}

			return ko.bindingHandlers.text.update(element, function(){
				return value.tm;
			});
		}
		else
		{
			ko.bindingHandlers.css.update(element, function(){
				return {'label label-success label-danger':false};
			});
		}

		return ko.bindingHandlers.text.update(element, function(){
			if (_if)
				return _date.format(_format);
			else
				return "";
		});
	}
};
ko.virtualElements.allowedBindings.date	= true;

ko.bindingHandlers.duedate	= {
	update: function(element, valueAccessor) {
		var value	= ko.utils.unwrapObservable(valueAccessor());

		var date	= ko.utils.unwrapObservable(value.date);
		if (!date) return "";

		var noDiff	= ko.utils.unwrapObservable(value.noDiff);

		var _if	= ko.utils.unwrapObservable(value.fi);
		_if	= (_if == undefined ? true : _if);

//		var _pref	= ko.utils.unwrapObservable(value.pref);
//		_pref	= (_pref == undefined ? true : _pref);

		var is_closed	= ko.utils.unwrapObservable(value.is_closed);

		date	= new Date(date);
		var diff	= (date.clearTime() - new Date().clearTime())/(1000*60*60*24);
		var html, className;

		className	= "label label-success";
		html	= noDiff ? date.format(Otime.dateFormat || "DD-MM-YYYY") : (diff + " d");

		if (date.isToday())
		{
			html	= "Today";
		}
		else if(date.isTomorrow())
		{
			html	= "Tomorrow";
		}
		else if(date.isYesterday())
		{
			html	= "Yesterday";
			className	= (is_closed ? "label label-default" : "label label-danger");
		}
		else if (diff < 0)
		{
			className	= is_closed ? "" : "text-danger";
		}

		if (!_if)
		{
			return "";
		}

		ko.bindingHandlers.css.update(element, function(){
			return className;
		});

		return ko.bindingHandlers.text.update(element, function(){
			return html;
		});
	}
};
// Activity date display
ko.bindingHandlers.actdate	= {
	update: function(element, valueAccessor) {
		var value	= ko.utils.unwrapObservable(valueAccessor());

		var date	= new Date(ko.utils.unwrapObservable(value.date));
		var is12	= ko.utils.unwrapObservable(value.is12);
		var noHrs	= ko.utils.unwrapObservable(value.noHrs);
		var format	= ko.utils.unwrapObservable(value.format);
		var str	= '';

		if (date.isToday())
		{
			str	+= 'Today ';
		}
		else if(date.isYesterday())
		{
			str += 'Yesterday ';
		}
		else if(format)
		{
			str += date.format(format) + ' ';
		}

		if (!format)
		{
			str = '';
		}

		if (!noHrs)
		{
			str += date.format(is12 ? 'OO:NN' : 'HH:NN AP');
		}

		return ko.bindingHandlers.text.update(element, function(){
			return str;
		});
	}
};

ko.bindingHandlers.shortdate	= {
	update: function(element, valueAccessor) {
		var value	= ko.utils.unwrapObservable(valueAccessor());
		var _val	= {};
		_val.from	= new Date(ko.utils.unwrapObservable(value.from));
		_val.to		= new Date(ko.utils.unwrapObservable(value.to));
		var ret	= "";

		ret	= _val.from.format((_val.from.getMonth() == _val.to.getMonth()) ? "DD" : "DD MMM");
		ret += " - ";
		ret += _val.to.format("DD MMM, YYYY");

		return ko.bindingHandlers.text.update(element, function(){
			return ret;
		});
	}
};

ko.bindingHandlers.hours	= {
	update: function(element, valueAccessor) { 
		var value	= ko.utils.unwrapObservable(valueAccessor());

		var _val	= ko.utils.unwrapObservable(value.val) || "";

		if (isNaN(_val))
		{
			return ko.bindingHandlers.text.update(element, function(){
				return _val;
			});
		}

		var _sep	= Otime.timeSeparator || ":";
		if (value.sep)
			_sep	= ko.utils.unwrapObservable(value.sep) || Otime.timeSeparator || ":";

		var _showNull	= "";
		if (typeof value.showNull != "undefined")
			_showNull	= ko.utils.unwrapObservable(value.showNull) || "";

		var _fix	= ko.utils.unwrapObservable(value.fix);

		_fix	= (typeof _fix == "undefined" ? 2 : _fix) - 0;

//		var _is_num	= false;
//		if (typeof value.num != "undefined")
//			_is_num	= !!ko.utils.unwrapObservable(value.num);

		_val = (_val != "") ? Number(_val).toFixed(_fix) : _val;
		var nullStr	= "";
		if (!(_val-0) && _showNull)
		{
			_val	= (0).toFixed(_fix);
			if (typeof _showNull === "string")
			{
				nullStr	= _showNull;
				_val	= "";
//console.log("Here : ", _val, "#", _showNull);
			}
		}
//console.log(_val, _showNull);
//		if (_is_num)
//			_val	= (_val-0 ? _val-0 : "");

		if (_val != "" && _sep == ":")
		{
			_val	= _val-0;
			var minutes	= Math.round((_val % 1)*60);
			var hrs	= _val - (_val % 1);
			if (_fix)
			{
				hrs	= (minutes<0 && hrs>=0) ? "-"+hrs : hrs;
				minutes	= Math.abs(minutes);
				minutes	= minutes<10 ? "0"+minutes : minutes;
			}
			_val	= (_fix==0)?hrs:(hrs + ":" + minutes);
		}
//console.log(nullStr, _val);
		return ko.bindingHandlers.text.update(element, function(){
			return _val || nullStr;
		});
	}
};
ko.virtualElements.allowedBindings.hours	= true;
/*
ko.bindingHandlers.bSwitch = {
    init: function (element, valueAccessor, allBindingsAccessor) {
        //initialize bootstrapSwitch
        $(element).bootstrapSwitch();
        // setting initial value
        $(element).bootstrapSwitch('state', valueAccessor()());
        //handle the field changing
        $(element).on('switchChange.bootstrapSwitch', function (event, state) {
            var observable = valueAccessor();
            observable(state);            
        });
        // Adding component options
        var options = allBindingsAccessor().bSwitchOpt || {};
        for (var property in options) {
            $(element).bootstrapSwitch(property, ko.utils.unwrapObservable(options[property]));
        }
        //handle disposal (if KO removes by the template binding)
        ko.utils.domNodeDisposal.addDisposeCallback(element, function () {
            $(element).bootstrapSwitch("destroy");
        });
    },
    //update the control when the view model changes
    update: function (element, valueAccessor, allBindingsAccessor) {
        var value = ko.utils.unwrapObservable(valueAccessor());
        // Adding component options
        var options = allBindingsAccessor().bSwitchOpt || {};
        for (var property in options) {
            $(element).bootstrapSwitch(property, ko.utils.unwrapObservable(options[property]));
        }
        $(element).bootstrapSwitch("state", value);        
    }
};
*/
/***
 * Usage
 * data-bind="concat:{val:[observable1, observable2], sep:'-'}"
 * data-bind="concat:{val:[observable1, 'value2']}"
 * <!-- ko concat:{val:[observable1, observable2], sep:'-'} --><!-- /ko -->
 * <!-- ko concat:{val:[observable1, 'value2']} --><!-- /ko -->
 */
//ko.bindingHandlers.concat	= {
//	update: function(element, valueAccessor) { 
//		var value	= ko.utils.unwrapObservable(valueAccessor());
//		var _vals	= ko.utils.unwrapObservable(value.val) || "";
//		var _sep	= ko.utils.unwrapObservable(value.sep) || "-";
//
//		_vals	= JSON.parse(ko.toJSON(_vals)).join(_sep);
//
//		return ko.bindingHandlers.text.update(element, function(){
//			return _vals;
//		});
//	}
//};
//ko.virtualElements.allowedBindings.concat	= true;

ko.bindingHandlers.stackedBar	= {
	update: function(element, params){
		var self	= {};
		self._params	= params() || {};
		if (!self._params.data)
		{
			return false;
		}

		var lines	= self._params.data.line || null;
		if (self._params.data.bars)
		{
			self._params.data	= [{
				data: self._params.data.bars[0].data,
				bars: {show: true}
			}, {
				data: self._params.data.bars[1].data,
				bars: {show: true}
			}, {
				data: self._params.data.line,
				lines: {show: true},
				stack: null
			}];
			$.plot($(element), self._params.data, {
				series: {
					stack: false
				},
				xaxis: {
					minTickSize: 1,
					ticks: (self._params.ticks ? self._params.ticks : null)
				},
				yaxis: {
					min : 0
				},
				colors: self._params.colors || ["#5F9EA0","#A52A2A","#008B8B", "#F4A460", "#9ACD32"],
				grid: {
					show: true,
					borderWidth: 0,
					hoverable: true,
					clickable: false
				}
			});
			return;
		}
		else
		{
			$.plot($(element), self._params.data, {
				xaxis: {
					minTickSize: 1,
					ticks: (self._params.ticks ? self._params.ticks : null)
				},
				yaxis: {
					min : 0
				},
				colors: self._params.colors || ["#FC8660", "#52D793", "#56A2CF", "#CE91DB", "#FCB660"],
				series: {
					bars: {
						show: true,
						barWidth: 0.8,
						align: "center"
					},
					stack: !!ko.utils.unwrapObservable(self._params.stack)
				},
				grid: {
					show: true,
					borderWidth: 0,
					hoverable: true,
					clickable: false
				},
				legend: {
					show: self._params.legend,
					noColumns: 1,
					labelFormatter: null,
					labelBoxBorderColor: "transparent",
					container: null,
					position: "ne",
//					margin: [0, 0, 0, 0],
					backgroundColor: "transparent"
//					backgroundOpacity: 0.7
				}
			});
		}

		if (!self._params.tooltip)
			return true;

		var previousPoint = null;
		$(element).bind("plothover", function(event, pos, item){
			if (item)
			{
				if (previousPoint != item.seriesIndex)
				{
					previousPoint = item.seriesIndex;
					$("#plotTip").remove();

					var value	= (item.datapoint[1] - item.datapoint[2]).toFixed(2);
					value	= (self._params.tooltip_format && typeof self._params.tooltip_format == "function") ? self._params.tooltip_format(value) : value;
					var tmp_tooltip = item.series.label + " " + (self._params.tooltip_lprefix ? self._params.tooltip_lprefix : '') +
					value +	(self._params.tooltip_lsuffix?self._params.tooltip_lsuffix:'');

					if (self._params.tooltip_params && self._params.tooltip_params[item.dataIndex]) {
						tmp_tooltip = tmp_tooltip+"<br>"+self._params.tooltip_params[item.dataIndex];
					}
					showTooltip(item.pageX, item.pageY, item.series.color,tmp_tooltip);
				}
			}
			else
			{
				$("#plotTip").remove();
				previousPoint = null;
			}
		});
	}
};

ko.bindingHandlers.multiBar	= {
	update: function(element, params){
		var self	= {};
		self._params	= params() || {};
		if (!self._params.data)
		{
			return false;
		}

		$.plot($(element), self._params.data, {
			xaxis: {
				minTickSize: 1,
				ticks: (self._params.ticks ? self._params.ticks : null)
			},
			yaxis: {
				min : 0
			},
			valueLabels: {
				show: true
			},
			colors: self._params.colors || ["#FC8660", "#52D793", "#56A2CF", "#CE91DB", "#FCB660", "#7cb5ec"],
			series: {
				bars: {
					show: true,
					barWidth: 0.26,
					align: "center",
					order: 1
				},
				stack: !!ko.utils.unwrapObservable(self._params.stack)
			},
			grid: {
				show: true,
				borderWidth: 0,
				hoverable: true,
				clickable: false
			},
			legend: {
				show: self._params.legend,
				noColumns: 1,
				labelFormatter: null,
				labelBoxBorderColor: "transparent",
				container: null,
				position: "ne",
				backgroundColor: "transparent"
			}
		});

		if (!self._params.tooltip)
			return true;

		var previousPoint = null;
		$(element).bind("plothover", function(event, pos, item){
			if (item)
			{
				if (previousPoint != item.seriesIndex)
				{
					previousPoint = item.seriesIndex;
					$("#plotTip").remove();
					showTooltip(item.pageX, item.pageY, item.series.color, item.series.label + " " + (self._params.tooltip_lprefix?self._params.tooltip_lprefix:'') +(item.datapoint[1] - item.datapoint[2]).toFixed(2)+ (self._params.tooltip_lsuffix?self._params.tooltip_lsuffix:''));
				}
			}
			else
			{
				$("#plotTip").remove();
				previousPoint = null;
			}
		});
	}
};


function showTooltip(x, y, color, contents) {
	$('<div id="plotTip">' + contents + '</div>').css({
		position: 'absolute',
		display: 'none',
		top: y - 20,
		left: x - 60,
		border: '2px solid ' + color,
		padding: '3px',
		'font-size': '12px',
		'border-radius': '5px',
		'background-color': '#fff',
		'font-family': 'Verdana, Arial, Helvetica, Tahoma, sans-serif',
		opacity: 0.9
	}).appendTo("body").fadeIn(200);
}
ko.bindingHandlers.pie	= {
	update: function(element, params) {
		var self	= {};
		self._params	= params() || {};
		if (!self._params.data)
		{
			return false;
		}

		self.radius	= self._params.rectangular ? 200 : 1;
		self.inner_radius	= self._params.donut ? 0.5 : 0;

		$.plot($(element), self._params.data, {
			colors: self._params.colors || ["#FC8660", "#52D793", "#56A2CF", "#CE91DB", "#CCCCCC", "#7cb5ec", "#FCB660"],
			series: {
				pie: {
					radius: self.radius,
					innerRadius: self.inner_radius,
					startAngle:1,
					show: true,
					tilt:1,
					label: {
						show: true,
						radius: 3/4,
						formatter: function(label, series){
							return "<div style='font-size:8pt; text-align:center; padding:2px; color:#FFF;'>" + Math.round(series.percent) + "%</div>";
						}
//						background: {
//							opacity: 0.4,
//							color: '#000000'
//						}
					}
				}
			},
			legend: {
				show: self._params.legend,
				noColumns: 1,
				labelFormatter: null,
				labelBoxBorderColor: "transparent",
				container: null,
				position: "ne",
//				margin: [0, 0, 0, 0],
//				backgroundColor: "#EFEFEF",
				backgroundOpacity: 0.7
			},
			grid: {
				hoverable: true,
				clickable: false
			}
		});

		var previousPoint = null;
		$(element).bind("plothover", function(event, pos, item){
			if (item)
			{
				if (previousPoint != item.seriesIndex)
				{
					previousPoint = item.seriesIndex;
					$("#plotTip").remove();
					showTooltip(pos.pageX, pos.pageY-10, item.series.color, item.series.label + " " + (self._params.tooltip_lprefix?self._params.tooltip_lprefix:'')+(item.datapoint[1][0][1]).toFixed()+(self._params.tooltip_lsuffix?self._params.tooltip_lsuffix:''));
				}
			}
			else
			{
				$("#plotTip").remove();
				previousPoint = null;
			}
		});
	}
};

ko.bindingHandlers.line	= {
	update: function(element, params){
		var self	= {};
		self._params	= params() || {};

		if (!self._params.data)
		{
			return false;
		}

		self.labels	= self._params.labels || [];
		self.tickSize	= (self.labels.length > 10) ? Math.round(self.labels.length/10) : 1;

//		Sample Data
//		self._params.data	= [{data:[[1, 14], [2, 35], [3, 98]], label: "Hours"}, {data:[[1,27], [2, 63], [3, 42]], label:"Average"}];

		var options	= {
			colors: self._params.colors || ["#008B8B", "#F4A460", "#9ACD32", "#A52A2A","#5F9EA0"],
			series: {
				lines: {
					show: true
				},
				points: {
					show: true
				}
			},
			grid: {
				show: true,
				borderWidth: 0,
				hoverable: true,
				clickable: false
			},
			yaxis: {
				tickLength: 0
//				min: 0,
//				max: 10
			},
			xaxis: {
				tickFormatter: function(x){
					return self.labels ? (self.labels[x] || x) : x;
				},
				tickSize: self.tickSize,
				tickLength: 0
//				min: 0,
//				max: 5
			},
			legend: {
				show: self._params.legend
			}
		};

		var plot	= $.plot($(element), self._params.data, options);
//		$("<img class='line-chart'>").attr("src", plot.getCanvas().toDataURL().replace("image/png", "image/octet-stream")).appendTo(element);

		if (!self._params.tooltip)
			return true;

		var previousPoint = null;
		$(element).bind("plothover", function(event, pos, item){
			if (item)
			{
				if (previousPoint != item.seriesIndex)
				{
					previousPoint = item.seriesIndex;
					$("#tooltip").remove();
//					item.series.label
					showTooltip(item.pageX, item.pageY, self.labels[item.dataIndex] + " : " + item.datapoint[1].toFixed(2));
				}
			}
			else
			{
				$("#tooltip").remove();
				previousPoint = null;
			}
		});
	}
};

function canvasToImage(canvas, backgroundColor)
{
	//cache height and width		
	var w = canvas.width;
	var h = canvas.height;
 
	var data;		
 
	if(backgroundColor)
	{
		//get the current ImageData for the canvas.
		data = context.getImageData(0, 0, w, h);
 
		//store the current globalCompositeOperation
		var compositeOperation = context.globalCompositeOperation;
 
		//set to draw behind current content
		context.globalCompositeOperation = "destination-over";
 
		//set background color
		context.fillStyle = backgroundColor;
 
		//draw background / rect on entire canvas
		context.fillRect(0,0,w,h);
	}
 
	//get the image data from the canvas				
	var imageData = this.canvas.toDataURL("image/png");
 
	if(backgroundColor)
	{
		//clear the canvas
		context.clearRect (0,0,w,h);
 
		//restore it with original / cached ImageData
		context.putImageData(data, 0,0);		
 
		//reset the globalCompositeOperation to what it was
		context.globalCompositeOperation = compositeOperation;
	}
 
	//return the Base64 encoded data url string
	return imageData;
}
//function showTooltip(x, y, contents) {
//	$('<div id="tooltip" class="tooltip">' + contents + '</div>').css({
//		position: 'absolute',
//		display: 'none',
//		top: y + 5,
//		left: x + 5,
//		'font-size': '11px'
//	}).appendTo("body").fadeIn(200);
//}


ko.undoableObservable = function(initialValue) {
	//private variables
	var _actual = ko.observable(initialValue);
	var _undos = ko.observableArray([]);
	var _redos = ko.observableArray([]);

	var result = ko.dependentObservable({
		read: function() {
			return _actual();
		},
		write: function(newValue) {
			_redos([]);
			_undos.push(_actual());
			_actual(newValue);
		}
	});

	//expose these flags to allow enabling/disabling buttons
	result.undoable = ko.dependentObservable(function() {
		return _undos().length > 0;
	});

	result.redoable = ko.dependentObservable(function() {
		return _redos().length > 0;
	});

	//go back to the latest undo value
	result.undo = function() {
		if (_undos().length > 0) {
			var last = _undos.pop();
			_redos.push(_actual());
			_actual(last);
		}
	};

	//redo the latest change
	result.redo = function() {
		if (_redos().length > 0) {
			var next = _redos.pop();
			_undos.push(_actual());
			_actual(next);
		}
	};

	return result;
};

/***
 * @param target - Target Item
 * @param isUndoable - Undo options or Boolean.
 * @returns target
 */
ko.extenders.undoable	= function(target, isUndoable){
	if (isUndoable)
	{
		target.subscribe(function(oldVal){
			if (!Otime.Tasks.history.flag)
			{
				Otime.Tasks.history.undoArr.push({
					prop: target,
					value: oldVal,
					list:[],
					type:isUndoable
				});
			}
		}, null, "beforeChange");
	}
	return target;
};

// Timesheet page tooltip.
ko.bindingHandlers.tooltip	= {
//	init: function(element, valueAccessor) {
//		var values	= ko.utils.unwrapObservable(valueAccessor());
//	},
	update: function(element, valueAccessor) {
		var values	= ko.utils.unwrapObservable(valueAccessor());

		if (values.html && typeof values.html == "function")
		{
			values.html	= values.html(ko.dataFor(element));
		}
		if (!values.html)
			return false;

		$(element).tooltip({
			placement: "top",
			title: values.html,
			html: true,
			container: "body",
			template: '<div class="tooltip" role="tooltip"><div class="tooltip-inner al" style="background:none;"></div></div>'
		});
	}
};

